package org.rcisoft.sys.attendance.util;

import java.util.List;
import java.util.stream.Collectors;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.google.common.collect.Lists;
import org.springframework.util.CollectionUtils;

public class PageUtil {
    /**
     * 获取分页数据
     *
     * @param items
     * @param page
     * @param <T>
     * @return
     */
    public static <T> Page<T> getPageData(List<T> items, Page page) {

        if (CollectionUtils.isEmpty(items)) {
            page.setTotal(0);
            page.setPages(0);
            return page;
        }

        page.setTotal(items.size());
        page.setPages(items.size() % page.getSize() == 0 ? items.size() / page.getSize() : items.size() / page.getSize() + 1);

        return page.setRecords(items.stream().skip(page.getSize() * (page.getCurrent() - 1)).limit(page.getSize()).collect(Collectors.toList()));
    }

    /**
     * 获取集合指定范围的数据
     * @param list
     * @param startIndex
     * @param endIndex
     * @param <T>
     * @return
     */
    public static <T> List<T> getDataBetweenIndex(List<T> list, int startIndex, int endIndex) {
        return CollectionUtils.isEmpty(list) ? list : endIndex < startIndex ? Lists.newArrayList() :
                list.stream().skip(startIndex).limit(endIndex - startIndex).collect(Collectors.toList());
    }
}
